import { inject as y, computed as l, ref as m, unref as n } from "vue";
const S = [
  // SPECIAL
  "primary",
  "itlab",
  // COLOR
  "red",
  "orange",
  "yellow",
  "green",
  "mint",
  "teal",
  "cyan",
  "blue",
  "indigo",
  "purple",
  "pink",
  // TEXT
  "color",
  "color-secondary",
  "color-tertiary",
  "color-quaternary",
  // BACKGROUND
  "background",
  "background-secondary",
  "background-tertiary",
  "background-blur",
  "background-opaque",
  // BORDER
  "border",
  "border-opaque",
  // OVERLAY
  "overlay-blur",
  "overlay-opaque",
  "overlay-background",
  // MENU
  "menu-background-blur",
  "menu-background-opaque",
  "menu-separator",
  // INPUT
  "input-field",
  "input-placeholder"
];
var F = /* @__PURE__ */ ((e) => (e.PRIMARY = "var(--lab-primary)", e.ITLAB = "var(--lab-itlab)", e.RED = "var(--lab-red)", e.ORANGE = "var(--lab-orange)", e.YELLOW = "var(--lab-yellow)", e.GREEN = "var(--lab-green)", e.MINT = "var(--lab-mint)", e.TEAL = "var(--lab-teal)", e.CYAN = "var(--lab-cyan)", e.BLUE = "var(--lab-blue)", e.INDIGO = "var(--lab-indigo)", e.PURPLE = "var(--lab-purple)", e.PINK = "var(--lab-pink)", e.COLOR = "var(--lab-color)", e.COLOR_SECONDARY = "var(--lab-color-secondary)", e.COLOR_TERTIARY = "var(--lab-color-tertiary)", e.COLOR_QUATERNARY = "var(--lab-color-quaternary)", e.BACKGROUND = "var(--lab-background)", e.BACKGROUND_SECONDARY = "var(--lab-background-secondary)", e.BACKGROUND_TERTIARY = "var(--lab-background-tertiary)", e.BACKGROUND_BLUR = "var(--lab-background-blur)", e.BACKGROUND_OPAQUE = "var(--lab-background-opaque)", e.BORDER = "var(--lab-border)", e.BORDER_OPAQUE = "var(--lab-border-opaque)", e.OVERLAY_BLUR = "var(--lab-overlay-blur)", e.OVERLAY_OPAQUE = "var(--lab-overlay-opaque)", e.OVERLAY_BACKGROUND = "var(--lab-overlay-background)", e.MENU_BACKGROUND_BLUR = "var(--lab-menu-background-blur)", e.MENU_BACKGROUND_OPAQUE = "var(--lab-menu-background-opaque)", e.MENU_SEPARATOR = "var(--lab-menu-separator)", e.INPUT_FIELD = "var(--lab-input-field)", e.INPUT_PLACEHOLDER = "var(--lab-input-placeholder)", e))(F || {});
const b = "itlab-theme-system-injection", d = "itlab-theme";
function f() {
  const e = y(b);
  return l(() => e ? e.theme.value : "light");
}
function q() {
  const e = y(b);
  return l({
    get: () => e ? e.storedTheme.value : "light",
    set: (t) => e && e.setTheme(t)
  });
}
function w() {
  const e = f();
  return l(() => e.value === "dark");
}
function x() {
  const e = f();
  return l(() => e.value === "light");
}
const E = "code{color:#c9d1d9;background:transparent}.code-doctag,.code-keyword,.code-meta .code-keyword,.code-template-tag,.code-template-variable,.code-type,.code-variable.language_{color:#ff7b72}.code-title,.code-title.class_,.code-title.class_.inherited__,.code-title.function_{color:#d2a8ff}.code-attr,.code-attribute,.code-literal,.code-meta,.code-number,.code-operator,.code-variable,.code-selector-attr,.code-selector-class,.code-selector-id{color:#79c0ff}.code-regexp,.code-string,.code-meta .code-string{color:#a5d6ff}.code-built_in,.code-symbol{color:#ffa657}.code-comment,.code-code,.code-formula{color:#8b949e}.code-name,.code-quote,.code-selector-tag,.code-selector-pseudo{color:#7ee787}.code-subst{color:#c9d1d9}.code-section{color:#1f6feb;font-weight:700}.code-bullet{color:#f2cc60}.code-emphasis{color:#c9d1d9;font-style:italic}.code-strong{color:#c9d1d9;font-weight:700}.code-addition{color:#aff5b4;background-color:#033a16}.code-deletion{color:#ffdcd7;background-color:#67060c}", A = "code{color:#24292e;background:transparent}.code-doctag,.code-keyword,.code-meta .code-keyword,.code-template-tag,.code-template-variable,.code-type,.code-variable.language_{color:#d73a49}.code-title,.code-title.class_,.code-title.class_.inherited__,.code-title.function_{color:#6f42c1}.code-attr,.code-attribute,.code-literal,.code-meta,.code-number,.code-operator,.code-variable,.code-selector-attr,.code-selector-class,.code-selector-id{color:#005cc5}.code-regexp,.code-string,.code-meta .code-string{color:#032f62}.code-built_in,.code-symbol{color:#e36209}.code-comment,.code-code,.code-formula{color:#6a737d}.code-name,.code-quote,.code-selector-tag,.code-selector-pseudo{color:#22863a}.code-subst{color:#24292e}.code-section{color:#005cc5;font-weight:700}.code-bullet{color:#735c0f}.code-emphasis{color:#24292e;font-style:italic}.code-strong{color:#24292e;font-weight:700}.code-addition{color:#22863a;background-color:#f0fff4}.code-deletion{color:#b31d28;background-color:#ffeef0}", D = ':root{--sait: env(safe-area-inset-top);--sail: env(safe-area-inset-left);--saib: env(safe-area-inset-bottom);--sair: env(safe-area-inset-right);--max-width: 1100px}html{color:var(--lab-color);background:var(--lab-background);-webkit-text-size-adjust:100%;-moz-text-size-adjust:100%;-ms-text-size-adjust:100%;text-size-adjust:100%;font-size:17px;font-family:IT Lab Standard,-apple-system,BlinkMacSystemFont,SF Pro Display,Helvetica Neue,Segoe UI,Roboto,Arial,noto sans,"apple color emoji","segoe ui emoji",segoe ui symbol,"noto color emoji",sans-serif;scroll-behavior:smooth;text-rendering:auto;-webkit-font-smoothing:antialiased}html:has(dialog[open]:modal) body{overflow:hidden;scrollbar-gutter:stable both-edges}html[no-scroll] body{overflow:hidden;scrollbar-gutter:stable both-edges}[font-standard]{font-family:IT Lab Standard,-apple-system,BlinkMacSystemFont,SF Pro Display,Helvetica Neue,Segoe UI,Roboto,Arial,noto sans,"apple color emoji","segoe ui emoji",segoe ui symbol,"noto color emoji",sans-serif}[font-rounded]{font-family:IT Lab Rounded,IT Lab Standard,-apple-system,BlinkMacSystemFont,SF Pro Display,Helvetica Neue,Segoe UI,Roboto,Arial,noto sans,"apple color emoji","segoe ui emoji",segoe ui symbol,"noto color emoji",sans-serif}[font-serif]{font-family:"IT Lab Serif",IT Lab Standard,-apple-system,BlinkMacSystemFont,SF Pro Display,Helvetica Neue,Segoe UI,Roboto,Arial,noto sans,"apple color emoji","segoe ui emoji",segoe ui symbol,"noto color emoji",sans-serif}body{margin:0;min-height:100vh;max-width:100vw;overflow-x:hidden;touch-action:pan-y}body,input,textarea{direction:ltr;text-align:left}*{-webkit-overflow-scrolling:touch}a{text-decoration:none;color:var(--lab-primary)}a:hover{text-decoration:underline}div[class^=page-]{min-height:calc(100vh - 220px)}div[class^=page-][secondary]{background:var(--lab-background-secondary)}p{font-size:17px;font-weight:400}[primary]{color:var(--lab-color)}[secondary]{color:var(--lab-color-secondary)}[tertiary]{color:var(--lab-color-tertiary)}[quaternary]{color:var(--lab-color-quaternary)}[lab-clamp]{word-break:normal;overflow:hidden;display:-webkit-box;-webkit-box-orient:vertical;text-overflow:ellipsis}[lab-meta]{font-size:12px;font-weight:700;color:var(--lab-color-secondary)}[lab-cover-header]{margin-top:calc(-94px - var(--sait));padding-top:calc(50px + var(--sait));border-top:44px solid var(--lab-background)}ul,ol,li,dl,dt,dd,h1,h2,h3,h4,h5,h6,hgroup,p,blockquote,figure,form,fieldset,input,legend,pre,abbr,button{margin:0;padding:0}';
function g(e, t, a) {
  const o = document.createElement("style");
  o.setAttribute("type", "text/css"), o.setAttribute("kind", "itlab-theme"), o.setAttribute("theme", e), o.setAttribute("purpose", "code-highlight"), o.innerHTML = t, document.head.appendChild(o), a || (o.disabled = !0);
}
function R(e) {
  g("light", A, e === "light"), g("dark", E, e === "dark");
}
function T() {
  const e = document.createElement("style");
  e.setAttribute("type", "text/css"), e.innerHTML = D, document.head.appendChild(e);
}
function i(e) {
  const t = document.createElement("link");
  t.setAttribute("rel", "stylesheet"), t.setAttribute("href", e), document.head.appendChild(t);
}
function _() {
  i("https://fonts.svi-itlab.com/standard.css"), i("https://fonts.svi-itlab.com/rounded.css"), i("https://fonts.svi-itlab.com/serif.css");
}
const s = {
  primary: "#DC2626",
  itlab: "#DC2626",
  red: "#FF3B30",
  orange: "#FF9500",
  yellow: "#FFCC00",
  green: "#34C759",
  mint: "#00C7BE",
  teal: "#30B0C7",
  cyan: "#32ADE6",
  blue: "#007AFF",
  indigo: "#5856D6",
  purple: "#AF52DE",
  pink: "#FF2D55",
  color: "#000000",
  "color-secondary": "#3C3C4399",
  "color-tertiary": "#3C3C434D",
  "color-quaternary": "#3C3C432E",
  background: "#FFFFFF",
  "background-secondary": "#F2F2F7",
  "background-tertiary": "#FBFBFD",
  "background-blur": "#FFFFFFB8",
  "background-opaque": "#FFFFFFE6",
  border: "#C6C6C8",
  "border-opaque": "#3C3C435C",
  "overlay-blur": "#FDFDFDCC",
  "overlay-opaque": "#F2F2F2CC",
  "overlay-background": "#00000080",
  "menu-background-blur": "#EDEDEDCC",
  "menu-background-opaque": "#EDEDED",
  "menu-separator": "#7676801F",
  "input-field": "#7676801F",
  "input-placeholder": "#3C3C4399"
  // = color-secondary
}, u = {
  primary: "#DC2626",
  itlab: "#DC2626",
  red: "#FF453A",
  orange: "#FF9F0A",
  yellow: "#FFD60A",
  green: "#30D158",
  mint: "#63E6E2",
  teal: "#40C8E0",
  cyan: "#64D2FF",
  blue: "#0A84FF",
  indigo: "#5E5CE6",
  purple: "#BF5AF2",
  pink: "#FF375F",
  color: "#FFFFFF",
  "color-secondary": "#EBEBF599",
  "color-tertiary": "#EBEBF54D",
  "color-quaternary": "#EBEBF52E",
  background: "#000000",
  "background-secondary": "#1C1C1E",
  "background-tertiary": "#161617",
  "background-blur": "#1D1D1FB8",
  "background-opaque": "#1D1D1FE6",
  border: "#38383A",
  "border-opaque": "#545458A5",
  "overlay-blur": "#00000099",
  "overlay-opaque": "#1E1E1EBF",
  "overlay-background": "#00000099",
  "menu-background-blur": "#00000069",
  "menu-background-opaque": "#000000",
  "menu-separator": "#7676803D",
  "input-field": "#7676803D",
  "input-placeholder": "#EBEBF599"
  // = color-secondary
};
function p(e) {
  return Array.isArray(e) || (e = [e]), [e[0], e[1] || e[0]];
}
function h(e, t, a) {
  const o = Object.entries(t).map(([v, k]) => `--lab-${v}:${k}`), r = document.createElement("style");
  r.setAttribute("type", "text/css"), r.setAttribute("kind", "itlab-theme"), r.setAttribute("theme", e), r.setAttribute("purpose", "variables"), r.innerHTML = `:root{${o.join(";")}}`, document.head.appendChild(r), a || (r.disabled = !0);
  const c = document.createElement("style");
  c.setAttribute("type", "text/css"), c.innerHTML = `[theme-${e}]{${o.join(";")}}`, document.head.appendChild(c);
}
function O(e, t) {
  if (e.primary) {
    const [a, o] = p(e.primary);
    s.primary = a, u.primary = o;
  }
  for (const [a, o] of Object.entries(e)) {
    if (a === "primary") continue;
    const [r, c] = p(o);
    s[`x-${a}`] = r, u[`x-${a}`] = c;
  }
  h("light", s, t === "light"), h("dark", u, t === "dark");
}
class B {
  /**
   * Initializes a new instance of the ThemeSystem class with the provided options.
   *
   * @param {ThemeSystemOptions} options - The options for configuring the theme system.
   */
  constructor(t) {
    const a = (o) => {
      localStorage.getItem(d) === "auto" && this.setTheme(o ? "dark" : "light", !1);
    };
    a(this.mediaquery.matches), this.mediaquery.addEventListener("change", (o) => a(o && o.matches)), _(), O(t, this.getTheme()), R(this.getTheme()), T();
  }
  /**
   * Media query to detect the user's preferred color scheme.
   *
   * @see {@link https://developer.mozilla.org/en-US/docs/Web/CSS/@media/prefers-color-scheme}
   */
  mediaquery = window.matchMedia("(prefers-color-scheme: dark)");
  /**
   * Retrieves the stored theme from local storage.
   *
   * @return {StoredTheme} the stored theme, which can be 'light', 'dark' or 'auto'.
   */
  getStoredTheme() {
    const t = localStorage.getItem(d);
    return t === "auto" ? "auto" : t === "dark" ? "dark" : "light";
  }
  /**
   * Retrieves the active theme based on the stored theme and the media query.
   *
   * @return {ActiveTheme} The active theme, which can be 'light' or 'dark'.
   */
  getTheme() {
    const t = this.getStoredTheme();
    return t === "auto" ? this.mediaquery.matches ? "dark" : "light" : t;
  }
  /**
   * Sets the theme for the application and optionally stores it in local storage.
   *
   * @param {StoredTheme} theme - the theme to be set
   * @param {boolean} [store=true] - flag indicating whether to store the theme in local storage
   * @return {void}
   */
  setTheme(t, a = !0) {
    ["dark", "light", "auto"].includes(t) || (t = "light"), a && (localStorage.setItem(d, t), this.storedTheme.value = t), t === "auto" && (t = this.mediaquery.matches ? "dark" : "light"), this.theme.value = t, document.querySelectorAll("style[kind=itlab-theme][theme=dark]").forEach((o) => o.disabled = t === "light"), document.querySelectorAll("style[kind=itlab-theme][theme=light]").forEach((o) => o.disabled = t === "dark");
  }
  /**
   * The currently active theme.
   *
   * Can be 'light' or 'dark'
   */
  theme = m(this.getTheme());
  /**
   * The currently stored theme.
   *
   * This is the theme that was last set, or 'light' if no theme has been set
   * yet. Can be 'light', 'dark', or 'auto'.
   */
  storedTheme = m(this.getStoredTheme());
}
const I = {
  /**
   * Installs the theme system plugin into the provided Vue app.
   *
   * @param {App} app - The Vue app to install the plugin into.
   * @param {ThemeSystemOptions} options - Optional configuration options for the theme system plugin.
   * @return {void}
   */
  install(e, t = {}) {
    const a = new B(t);
    Object.defineProperties(e.config.globalProperties, {
      $theme: { enumerable: !0, get: () => n(a.theme) },
      $setTheme: { enumerable: !0, get: () => (o) => a.setTheme(o) },
      $dark: { enumerable: !0, get: () => n(a.theme) === "dark" },
      $light: { enumerable: !0, get: () => n(a.theme) === "light" }
    }), e.provide(b, a);
  }
};
export {
  S as COLORS,
  F as Colors,
  I as ThemeSystemPlugin,
  w as useIsDark,
  x as useIsLight,
  q as useStoredTheme,
  f as useTheme
};
