export type ActiveTheme = 'dark' | 'light';
export type StoredTheme = ActiveTheme | 'auto';
export type ColorDefinition = string | [string] | [string, string];
export type ThemeSystemOptions = {
    primary?: ColorDefinition;
} & {
    [x: string]: ColorDefinition;
};
